import { useEffect, useRef, useState } from "react";
import { SpacingBlock } from "./SpacingBlock";

export function FadeIn({filepath}:{filepath: string}){
    const [isVisible, setVisible] = useState(false);
    const domRef = useRef(null)!;
    useEffect(() => {
        const observer = new IntersectionObserver(entries => {
        entries.forEach(entry => setVisible(entry.isIntersecting));
        {/* debug */}
        entries.forEach(entry => console.log(entry.isIntersecting));
        });
        observer.observe(domRef.current!);
    }, []);

    return (
        <>
            <div 
                className='col'
                style={{ 'height': '100vh'}}
                ref={domRef}>
                    <img 
                        style={{
                            'position': 'fixed',
                            'top': '20vh',
                            'left': '20vw',
                            'width': '60vw',
                            'height': '60vh',
                            'transition': 'opacity 0.6s ease-out, transform 1.2s ease-out',
                            'opacity': `${isVisible ? '1' : '0'}`,
                            'visibility': `${isVisible ? 'visible' : 'hidden'}`
                        }}
                        src={filepath}>
                    </img>
            </div>
        </>
    );
}